package analpilas;
class Pila{ //  Implementando Pila usando NodosEnl
    protected Nodo top;  //  Referencia de entrada
    protected boolean trace; // Trazamos ?
        
    public void setTrace(boolean trazar){trace = trazar;}
      
    public Pila(){top = null; trace = false;}
    
    public boolean vacia(){return top == null;} // No hay nodos 

    public String toString(){
	String aux = "Pila contiene ";
        int cont = 0;
        Nodo auxPtr;
        for(auxPtr = top; auxPtr != null; auxPtr = auxPtr.getProx())cont++;
	aux+= cont + " elementos\n";
	return aux;	
    }

		
    public void push(Object obj){
        top = new Nodo(obj,top);
        if(trace) System.out.println("incluido "+top);
    }

    public Nodo pop(){
	if(vacia()) return null; // Retornamos referencia nula
	Nodo ptr = top;	// Guardamos en aux la referencia del primer nodo
	top = top.getProx(); // Redirecionamos frente, saltando el primer nodo
	if (trace)System.out.println("excluido "+ptr);
	return ptr; //	Retornamos referencia nodo desvinculado
    }
}		
