package frase;
import java.io.IOException;
public class Caracter{
	private int car;   		// Parte interna de la clase, nuestro caracter

	Caracter(){car=' ';}    // Constructor, inicializa car en ' '

	Caracter(int cara){car = cara;} // Constructor, inicializa car mediante parmetro

	boolean esLetra(){ 		// Retorna true si verdadero, false caso contrario
		boolean letra = false;
		if(esLetMay()) letra=true;
		if(esLetMin()) letra=true;
		return letra;      //  Retornemos lo que haya sido
	} //  esLetra()

	boolean esLetMay(){		//  Es letra mayscula ?
		boolean mayus = false;
		String mayu = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		for(int i=0;i < mayu.length();i++)
			if(mayu.charAt(i)==car) mayus = true;  //  Es una letra mayscula
		return mayus;
	}

	boolean esLetMin(){		//  Es letra minuscula ?
		boolean minus = false;
		String minu = "abcdefghijklmnopqrstuvwxyz";
		for(int i=0;i < minu.length();i++)
			if(minu.charAt(i)==car) minus = true;  //  Es una letra minscula
		return minus;
	}

	boolean esVocal(){	 		//  Es vocal ?
		boolean vocal = false;
		String voca = "aeiouAEIOU";
		for(int i=0;i < voca.length();i++)
			if(voca.charAt(i) == car) vocal=true;  //  Es una vocal
		return vocal;                 //  Retornamos lo que sea ...
	}

	boolean esConso(){			//  Es consonante
		boolean conso = false;
		if(esLetra() && !esVocal()) conso=true;
		return conso;
	}

	boolean esDigDec(){			//  Es dgito decimal ?
		boolean digDec = false;
		String dig10 = "1234567890";
		for(int i=0;i < dig10.length();i++)
			if(dig10.charAt(i) == car) digDec=true;
		return digDec;
	}
        
        boolean pertPal(){  //  Caracter pertenece a la palabra?
                boolean pertenece = false;
                if(esLetra() || esDigDec())
                    pertenece = true;
                return pertenece; 
        } 
				
	boolean esDigHex(){			//  Es dgito hexadecimal ?
		boolean digHex = false;	
		String dig16 = "1234567890ABCDEF";
		for(int i=0;i < dig16.length();i++)
			if(dig16.charAt(i)==car) digHex=true;
		return digHex;
	}
			
	boolean esSigPun(){			//  Es signo de puntuacin ?
		boolean sigPun = false;	
		String punct = ".,;:";
		for(int i=0;i < punct.length();i++)
			if(punct.charAt(i) == car) sigPun=true;
		return sigPun;
	}
				
	boolean lecCar() throws java.io.IOException{  //  Lectura de caracteres con deteccin de fin	
		car = System.in.read(); // leemos caracter
		if(car=='#') return false;
		return true;
	}

	int getCar(){
		return car;            //  Retornamos el atributo car.
	}

	void setCar(int cara){
		car = cara;            //  Inicializamos el atributo car.
	}
};





