import Item;
class MatItems{            //	Matriz de objetos Items
	protected Item[][] item; // 
	protected int filas, cols;//  Dimensiones de la matriz
	public MatItems(int fil, int col, char tipo) { // Constructor
		int f,c,auxCod = 0;        // Una variable auxiliar
		filas=fil;cols=col;			// inicializamos tamao
		item = new Item[filas][cols]; // Generamos la matriz
		for(f=0;f<item.length;f++) 		// Barremos filas
			for(c=0;c<item[0].length;c++){ // y columnas
				switch(tipo){   // segun tipo de llenado requerido
					case 'A':{		// los haremos en secuencia ascendente
						auxCod = c;
						break;
					}
					case 'D':{		// o descendente ...
						auxCod = cols - c;
						break;
					}
					case 'R':{		// o bien randomicamentente (Al azar)
						auxCod = (int)(cols*Math.random());
					}
				}					//  switch
				item[f][c] = new Item();
				item[f][c].setCodigo(auxCod);
				item[f][c].setValor((float)(cols*Math.random()));
			}	// for(c=0
	}	//	public MatItems

	public String toString(){
		int ctos = (cols < 10 ? cols : 10);
		String aux = " Primeros "+ctos+" elementos de la fila 0\n";
		for(int i=0;i<ctos;i++)
			aux+=item[i][0].toString()+"\n";
		return aux;	
	}

	protected int cantCodEnFila(int cod, int fila){ 
		// Cuantas veces ocurre el cod parmetro en la fila parmetro     
		int cuantas = 0,i;
		for(i=0;i<item[fila].length;i++)
		  	if(item[fila][i].getCodigo() == cod)cuantas++;
		return cuantas;
	}
		 
	protected double promValCodEnCol(int cod, int col){ 
		//retorna el promedio de los valores asociados al cdigo parmetro 
		// en la columna parmetro. 
		int contCod = 0,i;
		double acuVal = 0.0, prom;
		for(i=0;i<item.length;i++)
		  	if (item[i][col].getCodigo() == cod){
				contCod++; acuVal+=item[i][col].getValor();
		  	}
		prom = (double)(acuVal/contCod);
		return prom;
	}	
}

