package ordpeincol;
import java.util.ArrayList;
public class OrdPeinCol{	//	Ordenamiento de un array de items
    private ArrayList<Item> colItems;
    private Item item;
    private int pas;           //  pasada
    public OrdPeinCol(int cant, char tipo){      //	Un constructor
	int 	auxCod = 0; // Una variable auxiliar
        colItems = new ArrayList<Item>();
	for(int i=0; i<cant; i++){    // la llenaremos de Item's, dependiendo
            switch(tipo){            // del tipo de llenado requerido
		case 'A':{           // los haremos en secuencia ascendente
                    auxCod = i;
			break;
		}
		case 'D':{	     // o descendente ...
                    auxCod = cant - i;
                    break;
		}
		case 'R':{	     // o bien randomicamentente (Al azar)
                    auxCod = (int)(cant*Math.random());
		}
            }
            item = new Item(auxCod,(float)(cant*Math.random()));
            colItems.add(item);
	}
    }

    void ordenar(boolean trace){	//programa de ordenamiento por peinado
        if(trace){
            System.out.println("Coleccin creada");
            System.out.print(colItems);
        }
 	int i,paso = colItems.size();
        Item itAct, itSig;
	boolean cambio;
        do {
            paso = (int)((float) paso/1.3);
            paso = paso>1 ? paso : 1;
            cambio = false;
            if(trace) System.out.println("paso vale "+paso);
            for (i = 0; i<colItems.size() - paso; i++){
                itAct = (Item)colItems.get(i);
                itSig = (Item)colItems.get(i+paso);
                if (itAct.esMayor(itSig)){
                    colItems.set(i,itSig);
                    colItems.set(i+paso,itAct);  
                    cambio = true;
		}
            }
            pas++; 
  	} while (cambio || paso > 1);
        if(trace){
            System.out.println("Coleccin ordenada");
            System.out.print(colItems);
        }
    }	// 	void ordenar
 }		//	public class OrdPein
