// La aplicacin crea un objeto stream de salida, el archivo se denomina cadena.txt. 
// El programa graba varios arrays de bytes inicializados desde cadenas, 
// Para tratar las excepciones se define un bloque try y un catch de captura.

import java.io.*;
class ArchivoCad{
	private int contLin = 0;
	public void demo(){
		String str = new String();
		String lineas[] =  {"La mas antigua de todas las filosofias",
						"la de la evolucion",
						"estuvo maniatada de manos y pies",
						"y relegada a la oscuridad mas absoluta ..."};
		byte [] s;

		try {
			FileOutputStream f = new FileOutputStream("cadena.txt");
			for(int i = 0; i < lineas.length;i++){
				s = lineas[i].getBytes(); // copia la cadena en el array de bytes s;
				f.write(s);				// graba el array de bytes
				f.write((byte)'\n') ;	// graba el avance de carro
				contLin++;				// cuenta
			}
		}	
		catch (IOException e){System.out.println("Problema grabacion");}
		finally {System.out.println("Grabadas "+contLin+" lineas (exito)");}
	}

	public static void main(String [] args){
		ArchivoCad arch = new ArchivoCad();
		arch.demo();
	}	 
}




