import java.io.*;
class CorreCaminos extends Corredor{
	protected char opcion;
	protected int minutes; 
	// Datos del archivo
	FileInputStream	miArch;
	DataInputStream entrada;

	public CorreCaminos(){
		super();
	}

	public 	boolean existeArchivo(){		
		System.out.println("Consultando archivo de corredores");
		System.out.print("Nombre archivo: ");
		String nomeArch = In.readLine();
		nomeArch+=".dat";
		file    = new File(nomeArch);		//	Instanciando objeto File
		if (!file.exists()){		
		 	System.out.println("No encuentro "+nomeArch);
			return false;
		}
		try{
			miArch = new FileInputStream(file);
			entrada = new DataInputStream(miArch);
		}
		catch (IOException e){
			System.out.println("Excepcin creando archivo");
			return false;
		}
		return true;
	}

	public void consulta(){
		System.out.println("Consulta por empatados");
		while (true){
			System.out.print("Cuantos minutos ? ");
			minutes = In.readInt();
			if (minutes > 0)break;
		}
		System.out.println(this);
	}

	public String toString(){
		boolean finArch = false;
		int cont = 0, cEmp = 0;
		String aux = "Corredores empatados\n";
		while (!finArch){
			try{
				nombre 		= entrada.readUTF();
				edad   		= entrada.readInt();
				categoria 	= entrada.readChar();
				sexo 		= entrada.readChar();
				minutos		= entrada.readInt();
				segundos	= entrada.readInt();
			}
			catch(EOFException eof){finArch = true;}
			catch(IOException io){aux+="Anomalia al procesar flujo";}
			if (!finArch){
			 	cont++;
			 	if (minutos == minutes){
					aux+=nombre+" , "+minutos+" , "+segundos+"\n";
					cEmp++;
				}
			}
		}
		aux+= "lectura terminada \n";		 	
		aux+="Leidos "+cont+", empat. "+cEmp+"\n";
		return aux;
	}
	
	public void queHago(){
		System.out.println("Por favor, opte:");
		System.out.println("Crear  archivo: 1");
		System.out.println("Consultarlo . . 2");
		System.out.print("Salir . . <Enter>");
		opcion = In.readChar();
		if (opcion == '1'){	// Debemos crear el archivo
			crearArchivo();
		}
		if (opcion == '2'){
			if (existeArchivo())
				consulta();
		}	
	}  		//	public void queHago

	public static void main(String[] args){
		CorreCaminos corre = new CorreCaminos();
		corre.queHago();
	}
}	
