// clase principal
import java.io.*;
class CreaCountry{
	File af; 
	RandomAccessFile arch; 
	MiCasa reg;
	final int MAXREG = 99;

	public CreaCountry(){
		try{
			af = new File("miCountry.dat");
			arch = new RandomAccessFile(af,"rw"); 
			reg = new MiCasa();

		}
		catch(IOException e){
			System.out.println("No se puede abrir el flujo."+e.getMessage());
			System.exit(1);
		}
	}		
	void archVacio(){
		try{
			reg = new MiCasa(); // crea registro vaco 
			for (int k = 1; k <= MAXREG; ++k){
				arch.seek(reg.desplazamiento(k)); 
				reg.altaReg(arch);
			}
		}
		catch(IOException e){
			System.out.println("Excepcin al mover puntero.del archivo"); 
			System.exit(1);
		}
	}

	void procesoEntrada(){
		BufferedReader entrada = new BufferedReader(
			new InputStreamReader(System.in));
		System.out.println("Para terminar, Nmero de orden = O");
		try{
			int nr;
			double x, y;
			String cd;
			boolean masRegistros = true;
			// bucle para la entrada 
			while (masRegistros){
				do{			// Ciclo de consistencia
					System.out.print("Nmero de orden:");
					nr = In.readInt();
				}while (nr<0 || nr>MAXREG);
				if (nr > 0 ){	// no es clave de salida
					reg.numOrden = nr;
					System.out.print("Nombre: ");
					cd = In.readLine();
					// se asegura un mximo de 40 caracteres
					reg.nombreCasa = cd.substring(0,Math.min(40,cd.length()));
					do{
						System.out.print("Coordenadas (x,y):");
						x = In.readDouble();
						y = In.readDouble();
					}while (x < 1.0 || x > 100.0 || y < 1.0 || y > 100.0);
					// escribe el registro en la posicin que le corresponde 
					reg.x = x;
					reg.y = y;
					arch.seek(reg.desplazamiento(nr));
					reg.altaReg(arch);
				}
				masRegistros =( nr > 0);
			}	// fin del bucle de entrada
		}
		catch(IOException e){System.out.println("Excepcin, termina el proceso ");
							System.exit(1);
		}
		finally{System.out.println("Se cierra el flujo ");}

		try{arch.close();}
		catch(IOException e){System.out.println("Error al cerrar el flujo");}
	}
	
	public static void main(String []args){
		CreaCountry country = new CreaCountry();
		country.archVacio();
		country.procesoEntrada();
	}
}

