import java.io.*;
class InputOutput10 implements Serializable{
    // Objetos de mis clases
    private Item item; 
    private ArrItems aItems;
    
    // Objetos clases Java
    private File file;          //  clase intermediaria
    private RandomAccessFile raf; // Archivo acceso directo
    private FileOutputStream fos; // Flujo de salida
    private ObjectOutputStream oos; // Flujo de salida objetos
    private FileInputStream fis;    // Flujo de entrada
    private ObjectInputStream ois;  // Flujo de entrada objetos
    private Object obj;             // Objeto generico
    boolean continuar;          // Mientras sea posible, continuar
    public InputOutput10(){     // Constructor, primer pto del enunciado
        aItems = new ArrItems(10,'R');
        continuar = true;
    }
    public void grbTodos(){     // Segundo punto del enunciado
        int grab = 0; 
        if(abroArchTodos())
	    try{
                for(grab = 0; grab <  aItems.talle;grab++){
		    raf.writeInt(aItems.item[grab].getCodigo());
		    raf.writeFloat(aItems.item[grab].getValor());
                    raf.writeBoolean(true);
		}
	    }catch(IOException e){System.out.println("Problemas grabando Todos.dat");
                              continuar = false;
            }finally {System.out.println("Grabados "+grab+" items");}
        else{
            System.out.println("Problemas abriendo Todos.dat");
            continuar=false;
        }
    }
    
    private boolean abroArchTodos(){
        boolean ok = true;
	try{
            file = new File("Todos.dat");
	    raf = new RandomAccessFile(file,"rw"); 
	}catch(IOException e){ok = false;}
        return ok;
    }
    
    public void grbCaros(float val){     // Tercer punto del enunciado
        int grab = 0;
        // Auxiliares para lectura desde Todos.dat
        int codAux; float valAux; boolean actAux;
        int despl = 0;  // desplazamiento 0: inicio del archivo;
        // Auxiliares para grabar caros.dat
        Item itAux = new Item(10,(float)(10.0));
        if(abroArchCaros()){
            try{
                raf.seek(despl);    // me posiciono al inicio de Todos.dat
                while(true){         // Ciclo de lectura
                    codAux = raf.readInt();
                    valAux = raf.readFloat();
                    actAux = raf.readBoolean();
                    if(actAux){      //  registro activo
                        if(valAux >= val){   // Corresponde grabar
                            itAux.setCodigo(codAux);
                            itAux.setValor(valAux);
                            oos.writeObject(itAux);
                            grab++;
                        }   //  if(valAux >= 
                    }     //  if(actAux)
                }       //  While(true)
            }catch(EOFException e){System.out.println("Grab. "+grab+" items");
            }catch(IOException e){System.out.println("IOException grabCaros()");}
                              continuar = false;
        }               //  if(abroArchCaros()
        else{
            System.out.println("Problemas abriendo Caros.dat");
            continuar=false;
        }       //  else
    }   //  public void grbCaros

    private boolean abroArchCaros(){
        boolean ok = true;
        try{
            fos=new FileOutputStream("Caros.dat");
            oos=new ObjectOutputStream(fos);
        }catch(IOException e){ok = false;}
        return ok;
    }
    public void demo(){
        grbTodos();             // Pto 2
        if (continuar)
            grbCaros((float)5.0);      // pto 3
    }
    
    public static void main(String args[]){
        InputOutput10 io10 = new InputOutput10(); // Pto 1
        io10.demo();
    }
}
