package busqbin;
class BusqBin{	//	Busqueda Binaria en un array de items
    int posic; 	//  Posicion del ultimo encuentro
    int clav;       //  Clave buscada
    ArrItems arrItems;  //  El array donde buscaremos
    public  BusqBin(int cant, char tipo){  	//	Un constructor                 
        arrItems = new ArrItems(cant,tipo); // que invoca otro
        posic = arrItems.talle+1;	//  posicin fuera del array
        clav  = 0;
    }	
    
    protected int leerClav(){
	clav = In.readInt();
	return clav;
    }

    protected boolean existe(int clave){;	// Existe la clave parmetro ?
	boolean exist = false; 
	int alt=arrItems.talle-1,baj=0;
	int indCent, valCent;
	while (baj <= alt){
            indCent = (baj + alt)/2;  	// ndice de elemento central
            valCent = arrItems.item[indCent].getCodigo(); // elemento central
            if (clave == valCent){       // encontrado valor;
                posic = indCent; exist = true; break;
            }
            else if (clave < valCent)
		alt = indCent - 1;   //	ir a sublista inferior
            else  baj = indCent + 1; // ir a sublista superior
        }
        return exist;                    // elenento no encontrado
    };

    protected int cuantas(int clave){; 	// Cuantas veces existe la clave ?
	int igual=0; boolean exist;		
	if (exist= existe(clave)){ // Si la clave existe, puede estar repetida
            for(int i=posic;i<arrItems.talle;i++)//  para arriba
		if (clave==arrItems.item[i].getCodigo())
                    igual++;
		else break;	
            for(int i=posic-1;i>0;i--)	// 	tambien para abajo
                if (clave==arrItems.item[i].getCodigo())
                    igual++;
                else break;
        }	
	return igual;
    }
    
    protected void demoBusqBin(){
	int cant;
        System.out.println("Que clave? (999: fin) ");
	while (leerClav() != 999){
            if((cant = cuantas(clav)) > 0)
		System.out.println("Cdigo " + clav + ", existe " + cant+" veces");
            else
		System.out.println("Codigo " + clav + " inexistente");
        }
	System.out.println("Demo finished!!!\n");
    }
}
