package implcolas;
class Cola{ 	
    protected Nodo top, bot;  //  Referencia de entrada
    protected boolean trace; // Trazamos ?

    public Cola(){   		//	Un constructor sin argumentos
        top = bot = null;
        trace = false;
    }		
    public void setTrace(boolean trazar){trace = trazar;}
    
    public boolean vacia(){return top == null;} // No hay nodos 

    public void add(Object item){
	Nodo aux;
	if (top == null){ //	no tenamos nodos, este es el primero
            bot = top = aux = new Nodo(item,null);
	}else{		//  Ya teniamos, este es uno mas ...
            aux = new Nodo(item,null);
            bot.setProx(aux);
            bot = aux;
	}	
	if(trace)
            System.out.print("incluido "+aux);
    }
    
    public Nodo remove(){
	if(vacia()) return null; // Retornamos referencia nula
	Nodo ptr = top;	// Guardamos en aux la referencia del primer nodo
	top = top.getProx(); // Redirecionamos top, saltando el primer nodo
	if(top == null) 	//	No hay ya nodos ...
            bot = null;
	if (trace)
            System.out.print("excluido "+ptr);
	return ptr;	//	Retornamos referencia nodo liberado
    }
    
    public String toString(){
	String aux = "Cola contiene ";
        int cont = 0;
        Nodo ptr;
        for(ptr = top; ptr != null; ptr = ptr.getProx())cont++;
	aux+= cont + " elementos\n";
	return aux;	
    }
}

