import Caracter;
public class Frase{
	private Caracter carAct, carAnt;
	private int contCar, contPal; 

	public Frase(){       		 //  Constructor,
		carAct = new Caracter(); //	instanciamos sus  		
		carAnt = new Caracter(); //	objetos atributos
		contCar = contPal = 0;
		System.out.println("\nIntroduzca caracteres, fin: #\n");
	}
	
	public void cicloCar(){
		carAnt.setCar(carAct.getCar()); //	Anterior <== Actual
	}
	
	public boolean actLetDig(){ 	// El actual es letra o digito ?
		boolean letDig = false;
		if  (carAct.esLetra() || carAct.esDigDec()) 	// Pertenece a la palabra
			letDig = true;	
		return letDig;
	}
	
	public boolean antLetDig(){ 	// El anterior es letra o digito ?
		boolean letDig = false;
		if  (carAnt.esLetra() || carAnt.esDigDec()) 	// Pertenece a la palabra
			letDig = true;	
		return letDig;
	}

	public boolean finPal(){		// Es fin palabra?
	    boolean fPal = false;
		if  (antLetDig() && !actLetDig())
			fPal = true; 	
		return fPal;
	}


	public void proFrase() throws java.io.IOException{   	// Nuestro ciclo de lectura de caracteres
		do { 
			carAct.lecCar(); 
			if (actLetDig()) contCar++;
			if (finPal())    contPal++;
			cicloCar();
		}while(carAct.getCar() != '#'); 	// Mientras la lectura no sea de un caracter '#'	
		System.out.println(this);
	}


	public String toString(){   			// la exhibicin de los resultados
		float 	auxPro = (float)contCar/contPal;
		String aux = "\n Totales \n";
		aux += "Procesamos frase con " + contPal + " palabras,\n";
		aux += "constituidas por     " + contCar  + " caracteres, \n";
		aux += "su longitud promedio " + auxPro  + " caracteres \n";
		aux += "Terminado !!!\n";
		return aux;
	}
};


