package implpilas;
class Pila { 
    private Nodo top;  //  Referencia de entrada
    private boolean trace; // Trazamos ?
    
    public Pila(){top = null; trace = false;}  // Constructor 

    public boolean vacia(){return top == null;} // No hay nodos 

    public String toString(){
	String aux = "Pila contiene ";
        int cont = 0;
        Nodo auxPtr;
        for(auxPtr = top; auxPtr != null; auxPtr = auxPtr.getProx())cont++;
	aux+= cont + " elementos\n";
	return aux;	
    }

    public void setTrace(boolean trazar){trace = trazar;}
		
    public void push(Object obj){
        top = new Nodo(obj,top);
        if(trace) System.out.print("incluido "+top);
    }

    public Nodo pop(){
	if(vacia()) return null; // Retornamos referencia nula
	Nodo ptr = top;	// Guardamos en aux la referencia del primer nodo
	top = top.getProx(); // Redirecionamos frente, saltando el primer nodo
	if (trace)System.out.print("excluido "+ptr);
	return ptr; //	Retornamos referencia nodo desvinculado
    }
}		
