package ordpein;
public class OrdPein{	//	Ordenamiento de un array de items
    private ArrItems arrItems;// mediante el mtodo Burbuja
    private int pas;          //  pasada
										// mediante el mtodo Peinado
    public OrdPein(int cant, char tipo){      //	Un constructor
        arrItems =  new ArrItems(cant,tipo);
	System.out.println("\nPasadas de ordenamiento");  
    }

    void ordenar(boolean trace){	//programa de ordenamiento por peinado
 	int i,paso = arrItems.talle;
	boolean cambio;
        do {
            paso = (int)((float) paso/1.3);
            paso = paso>1 ? paso : 1;
            cambio = false;
            for (i = 0; i<arrItems.talle-paso; i++)
                if (arrItems.item[i].esMayor(arrItems.item[i+paso])){
                    arrItems.item[i].intercambio(arrItems.item[i+paso]);
                    cambio = true;
		}
                pas++; if (trace) System.out.println(this);
  	} while (cambio || paso > 1);
    }	// 	void ordenar
    public String toString(){ // Mostrando los valores del array
	String aux  = "Pas "+pas+" ";
	int cuant=(arrItems.talle < 10 ? arrItems.talle : 10);  // Lo que sea menor
	for (int i=0;i<cuant;i++)
            aux += arrItems.item[i].getCodigo()+", ";
	return aux;
    }

}		//	public class OrdPein
