package ordsac;
public class OrdSac extends OrdBurb{	//	Ordenamiento de un array de items
										// mediante el mtodo Sacudida
    public OrdSac(int cant, char tipo){      //	Un constructor
	super(cant,tipo);
    }

    void ordenar(boolean trace){
      int j,k = arrItems.talle-1,iz = 1,de = arrItems.talle-1; Item aux;
      do{                      		// Ciclo de control de pasadas
        for (j = de; j>=iz; j--) // Pasada descendente
            if (arrItems.item[j].esMayor(arrItems.item[j-1])){
                arrItems.item[j].intercambio(arrItems.item[j-1]);
                k = j;      // Guardamos el lugar del ltimo intercambio
            }
        iz = k+1; pas++;
        if (trace) 
            System.out.println(this);  // Mostramos el array despues de la pasada
        for (j = iz; j<=de; j++)   // Pasada ascendiente
            if (arrItems.item[j].esMayor(arrItems.item[j-1])){
                arrItems.item[j].intercambio(arrItems.item[j-1]);
                k = j;                // Guardamos el lugar del ltimo intercambio
            }
        de = k-1; pas++;
        if (trace) 
            System.out.println(this);  // Mostramos el array despues de la pasada
      }while (iz<=de);
    }
}
