# include <C:\AED2004\Unidad2\Caracter\Caracter.cpp>
class  Palabra1{
private:
	Caracter carAnt, carAct;
	int contPal;               // Cuantas palabras contiene la frase?
	int contMayVoc;            // Cuantas palabras contienen mayoria vocales?
	int contIniTer;            // Cuantas palabra inician/terminan c/consonante
	int contVoc;               // Contador de vocales
	int contRes;               // Contador de los restantes caracteres
	int idIniCon;					// Identificador palabra inicia en consonante
	int  intPalab();  			// Estoy en el interior de una palabra ?
	int  finPalab();  			// Ha finalizado mi palabra ?
	void item1Int();           // Bloques de tratamiento de c/u de los
	void item2Int();           // items del enunciado. Los nombres terminados
	void item3Int();           // en Int tratan lo que corresponda del item
	void item1Fin();           // en el interior de la palabra, los que fina-
	void item2Fin();           // lizan en Fin idem en la finalizacin de la
	void item3Fin();           // palabra
	void toString();  			// la exhibicin de los resultados
public:
	Palabra1();						// Un constructor
	void proPalab();  			// Nuestro ciclo de lectura de caracteres
};

Palabra1::Palabra1(){     	//  Constructor
	contPal=contMayVoc=contIniTer=contVoc=contRes=idIniCon=0;
	// Todos los contadores a cero
};

int Palabra1::intPalab(){  	//  Estamos en el interior de la palabra ?
	int intP = 0;         		//  Suponemos lo contrario
	if(carAct.esLetra() || carAct.esDigDec()){  //  Recordemos que nuestras palabras
		intP = 1;               //  contienen letras y/o dgitos
	}
	return intP;
};

int Palabra1::finPalab(){  //  Suponemos que ya verificamos que no estamos
	int finP = 0;     		// en el interior de la palabra (Mtodo intPalab())
	if (carAnt.esLetra() || carAnt.esDigDec()) finP = 1;
									// si el anterior pertenece, es fin de palabra
	return finP;
};

void Palabra1::proPalab(){
	cout << "Introduzca caracteres, fin: # \n";
	carAct = cin.get();           //  Leemos el primero,
	while(!carAct.finDatos()){ 	//  Mientras no sea fin de caracteres ...
		if(intPalab()){            //  En el interior de la palabra,
			item1Int();					//  tratamos el primer item,
			item2Int();					//  tratamos el segundo,
			item3Int();					//  y el ltimo,
		}
		else if(finPalab()){  		// Finalizada,
			item1Fin();					//  tratamos el primer item,
			item2Fin();					//  tratamos el segundo,
			item3Fin();					//  y el ltimo,
		}
		carAnt = carAct;          		//  Siempre guardamos car en anterior
		carAct = cin.get();
	};  // while
	if(finPalab()){         		//  Al salir del ciclo puede quedar una
											// palabra sin procesar.
			item1Fin();					//  tratamos el primer item,
			item2Fin();					//  tratamos el segundo,
			item3Fin();					//  y el ltimo,
		}
	toString();
};

void Palabra1::item1Int(){;};      //  Nada que hacer aqu por el primer item

void Palabra1::item1Fin(){contPal++;};       //  Solo contar palabras ...

void Palabra1::item2Int(){
	if (carAct.esVocal())contVoc++;
	else contRes++;
};

void Palabra1::item2Fin(){
	if (contVoc > contRes)contMayVoc++;
	contVoc=contRes=0;
};

void Palabra1::item3Int(){
	if (contVoc+contRes==1)
		if (carAct.esConso())idIniCon=1;
};

void Palabra1::item3Fin(){
	if (idIniCon && carAnt.esConso())contIniTer++;
	idIniCon=0;
};

void Palabra1::toString(){
	cout << "= Totales =\n";
	cout << "Item 1 "<< contPal << " palabras, \n";
	cout << "Item 2 "<< contMayVoc << " idem   \n";
	cout << "Item 3 "<< contIniTer << " idem   \n";
	cout << "Terminado !!!\n";
};

void main(void){
	Palabra1 pal;        // Construimos el objeto
	pal.proPalab();  		// Procesar los datos;
};

