// Tratando objetos diversos: grabando, leyendo, reconociendo...
import java.io.Serializable;
import java.io.*;
class ObjDiv implements Serializable{ 
    private ArrItems arrItems;
    private String cadena = "Lo que es verdad a la luz de la lampara...";
    private Integer entero;
    private Float   decimal;
    private int grab =0, leid =0;
    public ObjDiv(int tam, char tipo){ 
        arrItems = new ArrItems(tam,tipo);
        entero   = new Integer(10);
        decimal  = new Float(10.55);
    }
    public void demoGrab() throws IOException{ 
        FileOutputStream arch=new FileOutputStream("backUp.tmp");
        ObjectOutputStream objOut=new ObjectOutputStream(arch);
        if( objOut!=null){ 
            objOut.writeObject(arrItems);   grab++;
            objOut.writeObject(cadena);     grab++;
            objOut.writeObject(entero);     grab++;     
            objOut.writeObject(decimal);    grab++;
            objOut.close();
            System.out.println("Objetos grabados: " + grab + " en backUp.tmp");
        }else System.out.println("Objeto objOut no instanciado (???)");
    }
    
    public void demoLect() throws IOException{ 
        FileInputStream arch=new FileInputStream("backUp.tmp");
        ObjectInputStream objIn=new ObjectInputStream(arch);
        Object obj;
        if( objIn!=null) 
            try{
                System.out.println("Objetos leidos");
                while(true){
                    obj = objIn.readObject();
                    leid++;
                    System.out.println("El objeto leido # " + leid + " es de "+obj.getClass());
                 }  
            }catch (EOFException eot){ objIn.close();
                System.out.println("Hemos leido " + leid +" objetos");
            }catch (ClassNotFoundException nfe){ 
                System.out.println("Class Not FoundException ");
            } finally {System.out.println("Demo finished !!! ");}
    }   //  void demoLect()
    public static void main(String[] args) throws IOException { 
        ObjDiv div = new ObjDiv(10,'R');
        div.demoGrab();
        div.demoLect();
    }
}   //  class ObjDiv

